%define expat_version 1.95.5
%define glib2_version 2.2.0
%define dbus_version  0.34
%def_disable selinux
%def_disable static

Name: hal
Version: 0.5.4
Release: alt6

Summary: Hardware Abstraction Layer
Summary(ru_RU.UTF-8): HAL - прослойка для абстрагирования оборудования
Summary(be_BY.UTF-8): HAL (Hardware Abstraction Layer) - праслойка абстрагаваньня абсталяваньня
Group: System/Servers
License: AFL/GPL
Url: http://www.freedesktop.org/wiki/Software_2fhal

Source0: %name-%version.tar.gz
Source1: hal-device-manager.desktop
Source3: %name-be.po.bz2

Source100: %{name}.init
Source101: 01-charset.fdi

Patch0: hal-0.5.3-alt-libhal-storage-mopts_collect-allow-string-options.patch
Patch1: hal-0.5.4-alt-storagepolicy.patch
Patch2: hal-0.5.3-alt-addproperty-disable_force_umount.patch
Patch3: hal-0.5.4-requires-fix.patch
Patch4: hal-fix-seqfault_if_addon_missing.diff
Patch5: hal-0.5.4-acpi_reconnect.patch
Patch6: hal-0.5.4-acpisupport-fix.patch

PreReq: lib%name = %version-%release
PreReq: udev >= 0.60
PreReq: mount >= 2.12p-alt1
PreReq: hotplug >= 2004_09_23-alt13
PreReq: chkconfig acpid

BuildPreReq: intltool perl-XML-Parser
#
BuildPreReq: kernel-headers-std26-up 
BuildPreReq: libexpat-devel >= %expat_version
BuildPreReq: glib2-devel >= %glib2_version
BuildPreReq: menu-devel
BuildPreReq: libdbus-devel >= 0.34-alt1

# Automatically added by buildreq on Wed Jul 13 2005 (-bi)
BuildRequires: OpenSP docbook-dtds docbook-style-dsssl docbook-utils doxygen gcc-c++ gcc-g77 glib2-devel libdbus-devel libdbus-glib-devel libexpat-devel libg2c-devel libpopt-devel libstdc++-devel libusb-devel menu-devel openjade perl-XML-Parser pkgconfig python-base python-dev python-modules-compiler python-modules-encodings sgml-common xml-common

%description
HAL is daemon for collection and maintaining information from several
sources about the hardware on the system. It provdes a live device
list through D-BUS.

%description -l ru_RU.UTF-8
HAL - это прослойка, абстрагирующая оборудование
%description -l be_BY.UTF-8
HAL (Hardware Abstraction Layer) - праслойка абстрагаваньня абсталяваньня

%package manager
Summary: GTK based device manager for HAL
Summary(ru_RU.UTF-8): Менеджер устройств для HAL
Summary(be_BY.UTF-8): Кіраўнік прыладаў для HAL які базуецца на GTK
Group: System/Configuration/Hardware
Requires: %name = %version-%release
Requires: python-module-pygtk >= 2.5.0
Requires: python-module-pygtk-libglade >= 2.5.0
Requires: python-module-pygnome >= 2.9.1
Requires: python-module-pyorbit >= 2.0.1

%description manager
GTK program for displaying the devices detected by HAL

%description manager -l ru_RU.UTF-8
Менеджер устройств для HAL.

%description manager -l be_BY.UTF-8
Кіраўнік прыладаў для HAL які базуецца на GTK.

%package -n lib%name
Summary: Shared libraries for HAL
Group: System/Libraries
Requires: dbus >= 0.34-alt5
Requires: hwdatabase >= 0.3.1

%description -n lib%name
This package provides shared libraries for HAL.

%package -n lib%name-devel
Summary: Libraries and headers for HAL
Summary(be_BY.UTF-8):	Файлы распрацоўкі патрэбныя для пабудовы дастасаваньняў з %name
Summary(ru_RU.UTF-8):	Файлы разработки нужные для построения приложений с %name
Group: Development/C
Obsoletes: %name-devel
Provides: %name-devel = %version-%release
Requires: lib%name = %version-%release libdbus-devel

%description -n lib%name-devel
Headers for HAL.

%description -n lib%name-devel -l be_BY.UTF-8
Файлы распрацоўкі патрэбныя для пабудовы дастасаваньняў з %name

%description -n lib%name-devel -l ru_RU.UTF-8
Файлы разработки нужные для построения приложений с %name

%package -n lib%name-devel-doc
Summary: Development documentation for HAL
Group: System/Libraries
Conflicts: lib%name-devel < %version-%release

%description -n lib%name-devel-doc
This package provides Development documentation for HAL.

%prep
%setup -q
%patch0 -p1
%patch1 -p1 -b .policy
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p1 -b .reconnect
%patch6 -p0

# belarusian translation
bzcat %SOURCE3 > po/be.po
%__subst 's,\(ALL_LINGUAS=\"\),\1be ,' configure.in

%build
%__libtoolize --copy --force
%__aclocal
%__autoconf
%__automake

%set_verify_elf_method textrel=relaxed

%configure \
	%{subst_enable static} \
	--enable-docbook-docs\
	--enable-fstab-sync\
	--enable-pcmcia-support\
	--enable-sysfs-carrier\
	--enable-hotplug-map\
	--disable-acpi-proc\
	--enable-largefile \
	--with-hal-user=root \
	%{subst_enable selinux} \
	--with-hwdata=/usr/share/hwdatabase \
	--with-pid-file=/var/run/hal.pid\
	--localstatedir=/var

%make_build

%install
%make_install DESTDIR=%buildroot install

%__install -d %buildroot%_docdir/lib%name-%version/examples \
	%buildroot/etc/rc.d/init.d

# init scripts
%__install %SOURCE100 %buildroot/etc/rc.d/init.d/hal

# default configurable policy:
%__install %SOURCE101 %buildroot/etc/hal/fdi/policy/

# docs and examples
%__install -m644 examples/volumed/*.py %buildroot%_docdir/lib%name-%version/examples/
%__mv %buildroot%_docdir/%name-%version/* %buildroot%_docdir/lib%name-%version/

# Make links in /etc/hal be relative... Still have to find a better (simpler) way
# to automate this task
for f in %buildroot%_sysconfdir/*/*/*; do
	echo "Checking \"$f\"..."
	[ -L "$f" ] || continue
	echo "Relocating \"$f\" -> \"`readlink $f`\""
	link="`readlink $f`"
	relname=`relative %buildroot$link $f`
	%__rm -f "$f" && ln -sf $relname $f
done

# fool the ALT building system a little to avoid dependency on 
# python-strict :-)
%__subst 's/^#!.*\/python\([ 	].*\)\?$/#!\/usr\/bin\/env python%__python_version\1/' %buildroot%_bindir/hal-device-manager


# .desktop file
%__mkdir_p %buildroot%_datadir/applications/
%__cp %SOURCE1 %buildroot%_datadir/applications/

# Menu entry
%__mkdir_p %buildroot%_menudir
freedesktop2menu.pl %name "Configuration/Hardware" \
    %buildroot%_datadir/applications/%name-device-manager.desktop \
    %buildroot%_menudir/%name-device-manager

subst 's/todo/_todo/' %buildroot%_sbindir/hal-system-power-set-power-save

%find_lang %name

%pre
# Add the "haldaemon" user
/usr/sbin/useradd -c 'HAL daemon' \
	-s /sbin/nologin -r -d '/' haldaemon 2> /dev/null || :

%post
%post_service hal

%post -n lib%name
%post_ldconfig

%post manager
%update_menus

%preun
%preun_service hal

%postun -n lib%name
%postun_ldconfig

%postun manager
%clean_menus

%files -f %name.lang
%dir %_sysconfdir/dbus-1/system.d
%config(noreplace) %verify(not size mtime md5) %_sysconfdir/dbus*/system.d/hal.conf
%config %_sysconfdir/rc.d/init.d/hal
#config(noreplace) %verify(not size mtime md5) %_sysconfdir/hal/hald.conf
%dir %_sysconfdir/hal
%dir %_sysconfdir/hal/fdi
%dir %_sysconfdir/hal/fdi/information
%dir %_sysconfdir/hal/fdi/policy
%config(noreplace) %_sysconfdir/hal/fdi/policy/*
%dir %_sysconfdir/hal/fdi/preprobe
%_sbindir/*
%_bindir/*
%exclude %_bindir/hal-device-manager
%_libexecdir/hal.hotplug
%_libexecdir/hald-addon-acpi
%_libexecdir/hald-addon-hid-ups
%_libexecdir/hald-addon-pmu
%_libexecdir/hald-addon-storage
%_libexecdir/hald-addon-usb-csr
%_libexecdir/hald-probe-hiddev
%_libexecdir/hald-probe-input
%_libexecdir/hald-probe-pc-floppy
%_libexecdir/hald-probe-printer
%_libexecdir/hald-probe-smbios
%_libexecdir/hald-probe-storage
%_libexecdir/hald-probe-volume
%_sysconfdir/hotplug.d/default/*.hotplug
%dir %_datadir/hal
%dir %_datadir/hal/fdi
%_datadir/hal/fdi/*
%_man8dir/fstab-sync.8*
%doc AUTHORS ChangeLog NEWS README doc/TODO

%files -n lib%name
%_libdir/*.so.*

%files -n lib%name-devel
%_includedir/*
%_libdir/*.so
%_libdir/pkgconfig/*

%files -n lib%name-devel-doc
%_docdir/lib%name-%version

%files manager
%_bindir/hal-device-manager
%dir %_datadir/hal/device-manager
%_datadir/applications/*
%_datadir/hal/device-manager/*
%_menudir/*

%changelog
* Thu Oct 20 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt6
- added patches from HEAD and SuSE:
    hal-0.5.4-acpi_reconnect.patch
    hal-fix-seqfault_if_addon_missing.diff
- disabled acpi-proc by default (always use acpid socket)
- todo() function renamed to _todo() in hal-system-power-set-power-save 
    (workarond for rpm-build bug #8211)

* Mon Oct 10 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt5
- typo in storagepolicy fixed

* Fri Sep 30 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt4
- policy for floppy fixed
- charset for cdrom devices fixed (#8067)
- mount option "sync" removed for usb devices

* Tue Sep 13 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt3
- storage policy for floppy devices fixed (#7551)
- libhal-devel added requires to libdbus-devel (#7863)

* Fri Sep 02 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt2.1
- fix for previos fix

* Wed Aug 31 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt2
- requires fixed

* Mon Aug 29 2005 Anton Farygin <rider@altlinux.ru> 0.5.4-alt1
- new version

* Wed Aug 17 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt9
- umask for iso9660 removed

* Wed Aug 17 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt8
- initscript priority changed from 98 to 47 (for running after dm)
- added default (for UTF-8) charset policy for fat filesystems

* Mon Aug 08 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt7
- more options for vfat and ntfs (#7551)
- fixed filelist (#7576)

* Wed Aug 03 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt6
- postun scriptlet removed (#7454)

* Fri Jul 22 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt5
- added key disable_force_umount for storage

* Thu Jul 21 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt4
- storage-policy: fixed managed key 
- storage-policy: revert back changes for subfs (moved to submountd package)

* Sun Jul 17 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt3
- added policy and scripts for mounting subfs
- renamed mountpoint for cd devices to cdrom

* Thu Jul 14 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt2
- --retain-privileges added to initscript (#7362)

* Wed Jul 13 2005 Anton Farygin <rider@altlinux.ru> 0.5.3-alt1
- new version
- added patch for allowed sting type options for mount (like fs=cdfss)

* Wed Mar 23 2005 Anton Farygin <rider@altlinux.ru> 0.4.7-alt3
- initscript stop/start fixed

* Tue Feb 08 2005 Anton Farygin <rider@altlinux.ru> 0.4.7-alt2
- storage-policy: added comment=managed mount option

* Wed Jan 26 2005 Anton Farygin <rider@altlinux.ru> 0.4.7-alt1
- 0.4.7
- added noexec, nosuid, nodev to default mount options
- don't use volume label for mount point names
- fixed pci.ids location (#6011)
- service haldaemon renamed to hal (#5995)

* Wed Jan 26 2005 Anton Farygin <rider@altlinux.ru> 0.4.4-alt5
- added patch for build with kernel-headers-std26-up
- removed requires to gnome-common

* Sun Jan 23 2005 Alexey Morozov <morozov@altlinux.org> 0.4.4-alt4
- Removed several reduntant dependencies, build- and installtime,
  made hal-manager be less demanding regarding python
- Replaced kernel-headers-std26-up w/ linux-libc-headers (from PLD)

* Mon Jan 10 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.4.4-alt3
- new libhal{,-devel{,-doc}} subpackages.
- gnome-common, kernel-headers-std26 required for build.
- rewrited haldaemon.

* Mon Jan 10 2005 Vital Khilko <vk@altlinux.ru> 0.4.4-alt2
- minor changes

* Mon Jan 10 2005 Vital Khilko <vk@altlinux.ru> 0.4.4-alt1
- 0.4.4
- added belarusian package description

* Thu Jan 06 2005 Vital Khilko <vk@altlinux.ru> 0.4.2-alt1
- 0.4.2
- added *.desktop and icon file for hal-device-manager
- two specs merged
- added belarusian translation
- set textrel=relaxed

* Tue Dec 14 2004 Alexey Morozov <morozov@altlinux.org> 0.4.1-alt1
- Initial build for ALTLinux (taken from PLD)
